/*

sid2pcm v0.1 by J. Reinhard finalmedia.de

This is my hacked/modified version of TinySID 0.94,
originally coded by T. Hinrichs and R. Sinsch !!

so it can be used as a filter (stdin/stdout).
First parameter is your SID Music File (Commodore C64),
output to stdout!

+++ Examples +++

usage via OSS (/dev/dspW):
sid2pcm [sid-file] > /dev/dspW
(samplerate 44.1 kHz, signed 16 bit little endianess,mono ! - e.g. using sox? and /dev/dsp !!!)

usage via alsa:
sid2pcm [sid-file] | aplay -c 1 -f s16_le -r 44100

usage with pulseaudio:
sid2pcm [sidfile] | pacat --format=s16le --rate=44100 --channels=1

usage with opusenc, a tiny standalone opus encoder:
sid2pcm [sidfile] | opusenc - --raw-bits 16 --raw-rate 44100 --raw-chan 1 --raw-endianness 0 --raw output.opus

or output to file:
sid2pcm [sid-file] > example.s16le.mono.pcm.

You can also pipe to ffmpeg and encode to different audiocodecs like opus, mp3, aac, ogg.
This is imho a much more flexible solution then directly accessing the soundcard

*/

#include <stdio.h>
#include <stdlib.h>
#include "sid2pcm.h"

static word init_addr, play_addr;
static byte actual_subsong, max_subsong, play_speed;
char song_name[32], song_author[32], song_copyright[32];

int j;
word soundbuffer[882*16];

int main(int argc, char *argv[])
{
        if (argc<2) {
		write(2,"usage: sid2pcm example.sid > out.pcm\n",40);
		return(1);
	}

	c64Init();
	synth_init(44100);

	if (c64SidLoad(argv[1], &init_addr, &play_addr, &actual_subsong, &max_subsong, &play_speed, song_name, song_author, song_copyright) == 0)
	{
	write(2,"error opening file\n",19); 
	return(1);
	}
	
	cpuJSR(init_addr, actual_subsong);

	while (1) {
	if (play_speed==0) { 
	for (j=0;j<8;j++) {
	cpuJSR(play_addr, 0);
	synth_render(&soundbuffer[882*j], 882); }
	}
	if (play_speed==1) {
	for (j=0;j<16;j++)
	{
	cpuJSR(play_addr, 0);
	synth_render(&soundbuffer[441*j], 441);
        }
	}

	write(1, soundbuffer, 882*8*2);
        }


	return(0);
}
